#include <stdint.h>
#include "capextend_hw.h"

void system_init( void );

// HeartRate 3 GPIO
sbit CAP_RST at GPIO_PIN1_bit;

//Global Declatations
uint8_t address     = 0x2B;
uint8_t my_buffer   = 0;
uint8_t int_flag    = 0;

void main()
{
     //Local Decalartions
     uint8_t msb        = 0;
     uint8_t lsb        = 0;
     uint8_t int_source = 0;
     uint8_t button     = 0;
     char uart_text[20] = { 0 };
     uint8_t count      = 0;

     system_init();
     Delay_ms(100);

     while(1)
     {
          msb = capextend_read_msb_buttons();
          lsb = capextend_read_lsb_buttons();
          GPIO_PORT_24_31 = lsb;
          GPIO_PORT_32_39 = msb;
          if( int_flag == 1 )
          {
              int_source = capextend_get_int_src();
              if( int_source == BUTTON_INT )
              {
                  UART1_Write_Text( "Button Pressed\r\n" );
              }
              int_flag = 0;
          }
     }  //While

}  //Main

void system_init( void )
{
     //GPIO setup
     GPIO_Digital_Output(&GPIO_PORT_24_31, _GPIO_PINMASK_ALL); // Set GPIO 24-31 port as digital output
     GPIO_Digital_Output(&GPIO_PORT_32_39, _GPIO_PINMASK_ALL); // Set GPIO 32-39 port as digital output
     GPIO_Digital_Input(&GPIO_PORT_00_07, _GPIO_PINMASK_0 | _GPIO_PINMASK_1);
     GPIO_Digital_Output(&GPIO_PORT_00_07, _GPIO_PINMASK_0 | _GPIO_PINMASK_1);
     

     //Toggle Reset Pin
     CAP_RST = 0;
     Delay_ms(50);
     CAP_RST = 1;
     Delay_ms(200);

     //Initialize UART
     UART1_Init( 9600 );
     Delay_ms(100);
     UART1_Write_Text( "UART Initialized\r\n" );

       //I2C Initialize
     I2CM1_Init(_I2CM_SPEED_MODE_STANDARD, _I2CM_SWAP_DISABLE);
     UART1_Write_Text( "I2C Initialized\r\n" );

     //Initialize Cap Extend
     capextend_init( address );
     UART1_Write_Text( "Cap Extend Initialized\r\n" );

}
